/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*- */
/*
 * bino
 * Copyright (C) Henrik Reinstädtler 2011 <henrik.linux@hotmail.com>
 * 
 * bino is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * bino is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "gettext.h"
#define _(string) gettext(string)
#include "dbg.h"
#include "msg.h"
#include "opt.h"
#include "playlist.h"
#include "media_input.h"
#include <vector>
#include <iostream>
#include <stdio.h>
#include <string>


playlist::playlist()
{
index=0;

}
playlist::~playlist()
{

}
void playlist::addItem(std::vector<std::string> FilePath)
{
	media_input* medium= new media_input();
	medium->open( FilePath);
		 if (medium->video_streams() == 0)
    {
        throw exc(_("No video streams found."));
    }
	Items.push_back(medium);
}
void playlist::addItem(media_input *Item)
{
	
	Items.push_back(Item);
}
void playlist::open(std::string FilePath)
{
	std::vector<std::string> input1;
	FILE *in_stream;
	media_input* data;
	if((in_stream = fopen(FilePath.c_str(),"r"))==NULL)
	{
		char *buffer;
	while(fgets(buffer,100,in_stream))
	{
		input1.push_back(std::string(buffer));		
		data = new  media_input();
		data->open(input1);
	Items.push_back(data);
		input1.clear();
	}
	}
	else 
{
printf(_("No Playlist found"));
exit(1);
}
	size= Items.size();
	delete data;
}
 void playlist::save(std::string FilePath)
{
	FILE *out_stream;
	if((out_stream = fopen(FilePath.c_str(),"w"))==NULL)
	{
int i;
	for(i=0;i<Items.size();i++)
	{
		fprintf(out_stream,"%s\n",Items.at(i)->url(0).c_str());
	}
	}
}
void playlist::next()
{
	index++;
}

void playlist::reset()
{
	index= -1;
	size=0;
	Items.clear();
}
void playlist::setTo(const int indexi)
{
	index= indexi;
}
void playlist::last()
{
	index= Items.size();
}
media_input* playlist::current()
{
	return Items.at(index);
}

